Attribute VB_Name = "General"
Option Explicit

Sub AddtoRichTextBox(RichTextBox As RichTextBox, text As String, Color As String)
Dim Red As Byte
Dim Green As Byte
Dim Blue As Byte
Dim Bold As Byte
Dim Italic As Byte
'******************************************
'Adds text to a Richtext box at the bottom.
'Automatically scrolls to new text.
'Text box MUST be multiline and have a 3D
'apperance!
'******************************************
Red = Val(ReadField(1, Color, 126))
Green = Val(ReadField(2, Color, 126))
Blue = Val(ReadField(3, Color, 126))
Bold = Val(ReadField(4, Color, 126))
Italic = Val(ReadField(5, Color, 126))

RichTextBox.SelStart = Len(RichTextBox.text)
RichTextBox.SelLength = 0
RichTextBox.SelColor = RGB(Red, Green, Blue)

If Bold Then
    RichTextBox.SelBold = True
Else
    RichTextBox.SelBold = False
End If

If Italic Then
    RichTextBox.SelItalic = True
Else
    RichTextBox.SelItalic = False
End If

RichTextBox.SelText = text & vbCrLf

End Sub
Sub AddtoTextBox(TextBox As TextBox, text As String)
'******************************************
'Adds text to a text box at the bottom.
'Automatically scrolls to new text.
'******************************************

TextBox.SelStart = Len(TextBox.text)
TextBox.SelLength = 0


TextBox.SelText = text & vbCrLf

End Sub

Sub LoadGameini()
Dim LoopC As Integer
Dim ln As String
'******************************************
'Load/s Game.ini
'******************************************

'Loads INIT's & Quick Arenas
If FileExist(IniPath & "Game.ini", vbNormal) = True Then
    UserName = GetVar(IniPath & "Game.ini", "INIT", "Name")
    UserPassword = GetVar(IniPath & "Game.ini", "INIT", "Password")
    UserSavePass = GetVar(IniPath & "game.ini", "INIT", "SavePass")
    UserArena = GetVar(IniPath & "Game.ini", "INIT", "Arena")
    UserServerIP = GetVar(IniPath & "Game.ini", "INIT", "ServerIP")
    UserPort = GetVar(IniPath & "Game.ini", "INIT", "Port")
    UserReconnect = GetVar(IniPath & "Game.ini", "INIT", "Reconnect")
    UserChats = GetVar(IniPath & "Game.ini", "INIT", "Chats")
    
    'Quick Arenas
    For LoopC = 1 To 5
        UserArenas(LoopC) = GetVar(IniPath & "Game.ini", "QUICKARENA", "Arena" & LoopC)
        'Sets Quick Arenas up
        frmMain.mnuArena(LoopC).Caption = UserArenas(LoopC)
    Next LoopC
    

    'Bots
    UserBot = GetVar(IniPath & "Game.ini", "BOT", "UseBot")
    
    For LoopC = 1 To 10
        ln = GetVar(IniPath & "Game.ini", "Bot", "Command" & LoopC)
        BotMode(LoopC).InCommand = ReadField(1, ln, 164)
        BotMode(LoopC).OutCommand = ReadField(2, ln, 164)
        BotMode(LoopC).UseCommand = Val(ReadField(3, ln, 164))
    Next LoopC
    
    'Anti Idle
    UserIdleCheck = GetVar(IniPath & "Game.ini", "IDLE", "UseIdle")
    UserIdleMsg = GetVar(IniPath & "Game.ini", "IDLE", "IdleMsg")
    UserIdleType = GetVar(IniPath & "Game.ini", "IDLE", "IdleType")
    UserIdleWait = GetVar(IniPath & "Game.ini", "IDLE", "IdleWait")
    
    'Greet
    UserGreetCheck = GetVar(IniPath & "Game.ini", "GREET", "UseGreet")
    UserGreetMsg = GetVar(IniPath & "Game.ini", "GREET", "GreetMsg")

    
Else
    'Sets defaults in case the person deleted Game.ini
    
    UserName = "Username"
    UserPassword = "Password"
    UserArena = "0"
    UserServerIP = "127.0.0.1"
    UserPort = 382
    UserBot = 0
    UserSavePass = 1
    UserChats = "Pokemon2001chat"
    
    UserGreetCheck = 0
    UserGreetMsg = "Welcome to %arena %lastplayer"
    
    UserIdleCheck = 0
    UserIdleWait = 1
    UserIdleType = 1
    UserIdleMsg = "ASSSChat v.%version anti-idle."
    
    'Sets Quick Arenas up
    For LoopC = 1 To 5
        UserArenas(LoopC) = "Arena" & LoopC
        frmMain.mnuArena(LoopC).Caption = UserArenas(LoopC)
    Next LoopC
    
End If
    
    'Saves the game.ini
    Call SaveGameini
    
End Sub

Sub SaveGameini()
Dim LoopC As Integer
'******************************************
'Saves Game.ini
'******************************************

'update Game.ini
'INIT
Call WriteVar(IniPath & "Game.ini", "INIT", "Name", UserName)
Call WriteVar(IniPath & "Game.ini", "INIT", "Password", UserPassword)
Call WriteVar(IniPath & "Game.ini", "INIT", "SavePass", Str(UserSavePass))
Call WriteVar(IniPath & "Game.ini", "INIT", "Arena", UserArena)
Call WriteVar(IniPath & "Game.ini", "INIT", "ServerIP", UserServerIP)
Call WriteVar(IniPath & "Game.ini", "INIT", "Port", Str(UserPort))
Call WriteVar(IniPath & "Game.ini", "INIT", "Reconnect", Str(UserReconnect))
Call WriteVar(IniPath & "Game.ini", "INIT", "Chats", UserChats)


'QUICKARENA 1 to 5
For LoopC = 1 To 5
    Call WriteVar(IniPath & "Game.ini", "QUICKARENA", "Arena" & LoopC, UserArenas(LoopC))
Next

'BOT
Call WriteVar(IniPath & "Game.ini", "BOT", "UseBot", Str(UserBot))

'Bot mode 1 to 10
For LoopC = 1 To 10
    Call WriteVar(IniPath & "Game.ini", "BOT", "Command" & LoopC, BotMode(LoopC).InCommand & "" & BotMode(LoopC).OutCommand & "" & BotMode(LoopC).UseCommand)
Next

'Anti Idle
Call WriteVar(IniPath & "Game.ini", "IDLE", "UseIdle", Str(UserIdleCheck))
Call WriteVar(IniPath & "Game.ini", "IDLE", "IdleMsg", UserIdleMsg)
Call WriteVar(IniPath & "Game.ini", "IDLE", "IdleType", Str(UserIdleType))
Call WriteVar(IniPath & "Game.ini", "IDLE", "IdleWait", Str(UserIdleWait))

'Greet
Call WriteVar(IniPath & "Game.ini", "GREET", "UseGreet", Str(UserGreetCheck))
Call WriteVar(IniPath & "Game.ini", "GREET", "GreetMsg", UserGreetMsg)

End Sub

Function CheckUserData() As Boolean
'*****************************************************************
'Checks all user data for mistakes and reports them.
'*****************************************************************

Dim LoopC As Integer
Dim CharAscii As Integer

'IP
If UserServerIP = vbNullString Then
    MsgBox ("Server IP box is empty.")
    Exit Function
End If

'Port
If Str(UserPort) = vbNullString Then
    MsgBox ("Port box is empty.")
    Exit Function
End If

'Password
If UserPassword = vbNullString Then
    MsgBox ("Password box is empty.")
    Exit Function
End If

If Len(UserPassword) > 10 Then
    MsgBox ("Password must be 10 characters or less.")
    Exit Function
End If

For LoopC = 1 To Len(UserPassword)

    CharAscii = Asc(Mid$(UserPassword, LoopC, 1))
    If LegalCharacter(CharAscii) = False Then
        MsgBox ("Invalid Password.")
        Exit Function
    End If
    
Next LoopC

'Name
If UserName = vbNullString Then
    MsgBox ("Name box is empty.")
    Exit Function
End If

If Len(UserName) > 20 Then
    MsgBox ("Name must be 20 characters or less.")
    Exit Function
End If

For LoopC = 1 To Len(UserName)

    CharAscii = Asc(Mid$(UserName, LoopC, 1))
    If LegalCharacter(CharAscii) = False Then
        MsgBox ("Invalid Name.")
        Exit Function
    End If
    
Next LoopC

'If all good send true
CheckUserData = True

End Function

Sub UnloadAllForms()
'*****************************************************************
'Unloads all forms
'*****************************************************************

On Error Resume Next

Unload frmBotSetup
Unload frmEditQuickArenas
Unload frmMain
Unload frmOptions
'this removes the icon from the system tray
Shell_NotifyIcon NIM_DELETE, nid

End Sub

Function LegalCharacter(keyascii As Integer) As Boolean
'*****************************************************************
'Only allow characters that are Win 95 filename compatible
'*****************************************************************

'if backspace allow
If keyascii = 8 Then
    LegalCharacter = True
    Exit Function
End If

'Only allow space,numbers,letters and special characters
If keyascii < 32 Then
    LegalCharacter = False
    Exit Function
End If

If keyascii > 126 Then
    LegalCharacter = False
    Exit Function
End If

'Check for bad special characters in between
If keyascii = 34 Or keyascii = 42 Or keyascii = 47 Or keyascii = 58 Or keyascii = 60 Or keyascii = 62 Or keyascii = 63 Or keyascii = 92 Or keyascii = 124 Then
    LegalCharacter = False
    Exit Function
End If

'else everything is cool
LegalCharacter = True

End Function

Sub SetConnected()
'*****************************************************************
'Sets the client to "Connect" mode
'*****************************************************************

'Set Connected
Connected = True

'Resets Mouse Pointer
frmMain.MousePointer = 0

'Save Game.ini
If frmOptions.ChkSavePass.value = 0 Then
    UserPassword = vbNullString
End If

Call SaveGameini

'Connection Keep-Alive timer
frmMain.TmrKeepAlive.Enabled = True

'Anti-Idles
If UserIdleCheck = 1 Then
    frmMain.TmrIdleMessage.Interval = UserIdleWait * 60000
    frmMain.TmrIdleMessage.Enabled = True
End If

End Sub

Public Function ReadField(Pos As Integer, text As String, SepASCII As Integer) As String
'*****************************************************************
'Gets a field from a string
'*****************************************************************

Dim i As Integer
Dim LastPos As Integer
Dim CurChar As String * 1
Dim FieldNum As Integer
Dim Seperator As String

Seperator = Chr(SepASCII)
LastPos = 0
FieldNum = 0

For i = 1 To Len(text)
    CurChar = Mid(text, i, 1)
    If CurChar = Seperator Then
        FieldNum = FieldNum + 1
        If FieldNum = Pos Then
            ReadField = Mid(text, LastPos + 1, (InStr(LastPos + 1, text, Seperator, vbTextCompare) - 1) - (LastPos))
            Exit Function
        End If
        LastPos = i
    End If
Next i
FieldNum = FieldNum + 1

If FieldNum = Pos Then
    ReadField = Mid(text, LastPos + 1)
End If


End Function

Function FileExist(File As String, FileType As VbFileAttribute) As Boolean
'*****************************************************************
'Checks to see if a file exists
'*****************************************************************

If Dir(File, FileType) = vbNullString Then
    FileExist = False
Else
    FileExist = True
End If

End Function

Sub Main()
'*****************************************************************
'Main
'*****************************************************************
Dim LoopC As Integer

'***************************************************
'Start up
'***************************************************
'****** Init vars ******
ENDC = Chr(10)
IniPath = App.Path & "\"

'Loads the game ini
Call LoadGameini

'****** Display frmMain window ******
frmMain.Visible = True

'***************************************************
'Main Loop
'***************************************************
prgRun = True
Do While prgRun
            
    '****** Go do other events ******
    DoEvents

Loop
    
'***************************************************
'Close Down
'***************************************************

'****** Unload forms and end******
Call UnloadAllForms
End

End Sub

Sub WriteVar(File As String, Main As String, Var As String, value As String)
'*****************************************************************
'Writes a var to a text file
'*****************************************************************

WritePrivateProfileString Main, Var, value, File

End Sub

Function GetVar(File As String, Main As String, Var As String) As String
'*****************************************************************
'Gets a Var from a text file
'*****************************************************************

Dim l As Integer
Dim Char As String
Dim sSpaces As String ' This will hold the input that the program will retrieve
Dim szReturn As String ' This will be the defaul value if the string is not found

szReturn = vbNullString

sSpaces = Space(5000) ' This tells the computer how long the longest string can be. If you want, you can change the number 75 to any number you wish


GetprivateProfileString Main, Var, szReturn, sSpaces, Len(sSpaces), File

GetVar = RTrim(sSpaces)
GetVar = Left(GetVar, Len(GetVar) - 1)

End Function

Function Variables(ByVal Variable As String) As String
    Variable = Replace(Variable, "%arena", UserArena)
    Variable = Replace(Variable, "%players", UsersOnline)
    Variable = Replace(Variable, "%randomperson", "")
    Variable = Replace(Variable, "%lastperson", LastUserName)
    Variable = Replace(Variable, "%time", Time)
    Variable = Replace(Variable, "%date", Date)
    Variable = Replace(Variable, "%uptime", ConvertTime(GetTickCount()))
    Variable = Replace(Variable, "%cmdperson", UserCmdPerson)
    Variable = Replace(Variable, "%version", Version)
    Variables = Variable
End Function

Function ConvertTime(ByVal lngMS As Long) As String
    Dim lngSeconds As Long, lngDays As Long, lngHours As Long, lngMins As Long
    Dim strSeconds As String, strDays As String
    lngSeconds = lngMS / 1000
    lngDays = Int(lngSeconds / 86400)
    lngSeconds = lngSeconds Mod 86400
    lngHours = Int(lngSeconds / 3600)
    lngSeconds = lngSeconds Mod 3600
    lngMins = Int(lngSeconds / 60)
    lngSeconds = lngSeconds Mod 60
    If lngSeconds <> 1 Then strSeconds = "s"
    If lngDays <> 1 Then strDays = "s"
    ConvertTime = lngDays & " day" & strDays & ", " & lngHours & " hours, " & lngMins & " minutes and " & lngSeconds & " second" & strSeconds
End Function

Function Version()
'**********************
'Gets version
'**********************

Version = App.Major & "." & App.Minor & "." & App.Revision

End Function

